;	Main file to run from 128*8k = 1MB Atarimax cartridge (cartridge type 42).
;
;	@com.wudsn.ide.asm.outputfileextension=.rom


	.if .not .def standalone
	.def standalone = 0
	.endif

	icl "ST-NICC-Equates.asm"

bank	= $80
la000	= $a000

;
; Start of code
;
	opt h-f+
	org la000

	jmp boot_start
	m_version

	.proc boot_start

	ldx #$00
loop1	lda rom_start,x
	sta ram_start,x
	inx
	bne loop1
loop2	lda rom_start+$100,x
	sta ram_start+$100,x
	inx
	bne loop2
	jmp ram_start

rom_start

	.proc ram_start,$700

	lda consol
	and #$04
	bne no_coldstart
	sta carctl+$80
	jmp coldsv

no_coldstart
	lda rtclok+2
wait	cmp rtclok+2
	beq wait

	ldx #1
	lda $d600+vbxe_core_version_offset
	cmp #$10
	beq vbxe_found
	inx
	lda $d700+vbxe_core_version_offset
	cmp #$10
	beq vbxe_found
	
	mwa #error_dlist sdlstl
	mva #$38 color0
	mva #$22 sdmctl
	mva #$e0 chbas
	jmp *

	.local error_dlist
:10	.byte $70
	.byte $46,a(text),$70,$06
	.byte $41,a(error_dlist)
	.endl
	
	.local text
	.sb "VBXE BOARD REQUIRED."
	.sb "    PRESS RESET.    "
	.endl

vbxe_found
	stx bank

	lda #$00
	sta nmien
	sta dmactl
	sei
	ldy #$fe
	sty portb

	jsr copy_8k_bank
	sta carctl+$80

	lda trig3
	sta gintlk
	jmp demo

	.proc copy_8k_bank
	ldx bank
	sta carctl,x
	inc bank

	lda #>la000
	sta from+1

	ldy #>[.len d600_version]
	ldx #$00
loop
	lda $ff00,x
from	= *-2
	sta demo,x
to	= *-2
	inx
	bne loop
	inc from+1
	inc to+1
	dey
	bne loop
	rts
	.endp
  	
  	.endp
  	
  	.endp
  
  	.align $bff4,0
  	org $bff4
cart_init
  	sta carctl	;Activate bank 0
  	jmp la000

  	.word la000
  	.byte $00,$04
  	.word cart_init

	.local d600_version
	ins "ST-NICCC-Blitter-$d600.xex",+6 ;$1000-$2fff, one 8k bank
	.endl
	.local d700_version
	ins "ST-NICCC-Blitter-$d700.xex",+6 ;$1000-$2fff, one 8k bank
	.endl
	m_ins $0000,scene_file_size
cart_end
	.echo "Cart end at ", cart_end
	ins "EmptyCart.rom",+0,$80*$2000-cart_end+la000-$c


;	Bank 127, $bff4
  	sta carctl	;Activate bank 0
  	jmp la000
  
  	.word la000
  	.byte $00,$04
  	.word cart_init
  	