;	Main file to run from 128*8k = 1MB Atarimax cartridge (cartridge type 42).
;
;	@com.wudsn.ide.asm.outputfileextension=.rom


;
; Code equates
;
	icl "SystemEquates.asm"

l1000	= $1000
l3000	= $3000
la000	= $a000
main	= $1091

;
; Start of code
;
	opt h-f+
	org $a000

	.proc boot_start

	ldx #$00
loop1	lda rom_start,x
	sta ram_start,x
	inx
	bne loop1
loop2	lda rom_start+$100,x
	sta ram_start+$100,x
	inx
	bne loop2
	jmp ram_start

rom_start

	.proc ram_start,$700

	lda consol
	and #$04
	bne no_coldstart
	sta carctl+$80
	jmp coldsv

no_coldstart
	lda rtclok+2
wait	cmp rtclok+2
	bne wait
	lda #$00
	sta nmien
	sta dmactl
	sei
	ldy #$fe
	sty portb

	sta carctl+1
	lda #>la000
	sta copy_8k.from+1
	lda #>l1000
	sta copy_8k.to+1
	jsr copy_8k

	sta carctl+2
	lda #>la000
	sta copy_8k.from+1
	lda #>l3000
	sta copy_8k.to+1
	jsr copy_8k
	sta carctl+$80

	lda trig3
	sta gintlk
	lda #$00
	sta audctl
	lda #$03
	sta skctl
	jmp main

	.proc copy_8k
	ldy #$20
	ldx #$00
loop
	lda la000,x
from	= *-2
	sta l1000,x
to	= *-2
	inx
	bne loop
	inc from+1
	inc to+1
	dey
	bne loop
	rts
	.endp
  	
  	.endp
  	
  	.endp
  
  	.align $bff4,0
  	org $bff4
cart_init
  	sta carctl
  	jmp la000

  	.word la000
  	.byte $00,$04
  	.word cart_init

	ins "ST-NICCC-Blitter.xex",+6 ;$1000-$2fff 1 bank
:8192	.byte 0
	ins "ST-NICCC-Scene.bin" ;,0,78*8192
	ins "EmptyCart.bin",81*8192+1000
